#!/bin/sh

CONFIG="/etc/samba/smb.conf"
TEXT="#patched"

# Check that smb.conf exists.
[ -f ${CONFIG} ] || exit 0

# Check that we can write to it... so non-root users stop here
[ -w ${CONFIG} ] || exit 0

# Check that we have to add our block into smb.conf
grep_result=`grep "$TEXT" ${CONFIG}`

if [ -z "$grep_result" ]
then
  echo "patching smb.conf..."

  #=== Patching BEGIN ===#

## This piece is intended to remove global user forcing and make per-flolder user forcing, add "#patched" tag to first line
#    echo "$(sed "1i${TEXT}" "${CONFIG}" | sed -e  "/force user = root/d;/\[.*\]/a\        force user = root" | sed "/\[global\]/{n;d}")" > "${CONFIG}"
  VENDOR_NAME=`sed -n '/^\s*vendor.name = /p' /usr/local/pancetera/etc/brand.txt|cut -d = -f2|sed 's/^\s*//'`
  PRODUCT_NAME=`sed -n '/^\s*vendor.product = /p' /usr/local/pancetera/etc/brand.txt|cut -d = -f2|sed 's/^\s*//'`

  echo "${TEXT}
[global]
    force user = root
    server string = \"${VENDOR_NAME} ${PRODUCT_NAME}\"
    security = share
    printing = bsd
    load printers = no
    disable spoolss = yes
    unix password sync = yes
    #log level = 6
    log file = /var/log/samba/samba.log.%m
    max log size = 500
    debug timestamp = yes
    passdb backend = smbpasswd
    oplocks = no

[share]
        path = /opt/share
        comment = \"${VENDOR_NAME} Share\"
        browseable = yes
        writeable = no
        printable = no
        public = yes
        profile acls = yes
        hide dot files = no

[mount]
        path = /opt/mount
        comment = \"${VENDOR_NAME} VMDK disks folder\"
        browseable = no
        writeable = no
        printable = no
        public = yes
        profile acls = yes

" > "${CONFIG}"

  #=== Patching END ===#

  echo "done"
else
  echo "smb.conf is already patched"
fi
